sub duplo_ui_ui_ui()
 REM		$Id$
 REM	Copyright (c) New Deal 1997 -- All Rights Reserved
 REM	FILE:		STDINC.BH

 STRUCT TimeOfDay
  DIM hour as integer
  DIM minute as integer
  DIM second as integer
 END STRUCT

 STRUCT Date
  DIM year as integer
  DIM month as integer
  DIM day as integer
 END STRUCT

 STRUCT Notification
  DIM arg1 as integer
  DIM arg2 as integer
  DIM arg3 as integer
  DIM arg4 as integer
  DIM arg5 as string
  DIM arg6 as complex
 END STRUCT

REM useful color constants
CONST WHITE 		&Hffffffff
CONST BLACK 		&Hff000000
CONST GRAY_50 		&Hff808080, GREY_50 		&Hff808080
CONST DARK_GRAY 	&Hff555555, LIGHT_GRAY		&Hffaaaaaa
CONST DARK_GREY 	&Hff555555, LIGHT_GREY		&Hffaaaaaa
CONST DARK_GREEN	&Hff00aa00, LIGHT_GREEN 	&Hff55ff55
CONST DARK_BLUE 	&Hff0000aa, LIGHT_BLUE		&Hff5555ff
CONST DARK_CYAN		&Hff00aaaa, LIGHT_CYAN		&Hff55ffff
CONST DARK_PURPLE	&Hffaa00aa, LIGHT_PURPLE	&Hffff55ff
CONST DARK_RED		&Hffaa0000, LIGHT_RED		&Hffff5555
CONST BROWN		&Hffaa5500, YELLOW		&Hffffff55

REM useful text style constants
CONST UNDERLINE		1
CONST STRIKE_THRU	2
CONST SUBSCRIPT		4
CONST SUPERSCRIPT	8
CONST ITALIC		16
CONST BOLD		32

REM useful Boolean constants
CONST TRUE		1
CONST FALSE		0

REM sound constants
CONST SS_ERROR		0
CONST SS_WARNING	1
CONST SS_NOTIFY		2
CONST SS_NO_INPUT	3
CONST SS_KEY_CLICK	4
CONST SS_ALARM		5

CONST MOUSE_PRESS 1, MOUSE_HOLD 2, MOUSE_DRAG 3, MOUSE_TO 4, MOUSE_RELEASE 5
CONST MOUSE_LOST 6, MOUSE_FLY_OVER 7

CONST C_SYS_00			&Hff00
CONST C_SYS_FF			&Hffff
CONST C_SYS_BACKSPACE		&Hff08
CONST C_SYS_TAB			&Hff09
CONST C_SYS_ENTER		&Hff0d
CONST C_SYS_ESCAPE		&Hff1b
CONST C_SYS_F1			&Hff80
CONST C_SYS_F2			&Hff81
CONST C_SYS_F3			&Hff82
CONST C_SYS_F4			&Hff83
CONST C_SYS_F5			&Hff84
CONST C_SYS_F6			&Hff85
CONST C_SYS_F7			&Hff86
CONST C_SYS_F8			&Hff87
CONST C_SYS_F9			&Hff88
CONST C_SYS_F10			&Hff89
CONST C_SYS_F11			&Hff8a
CONST C_SYS_F12			&Hff8b
CONST C_SYS_F13			&Hff8c
CONST C_SYS_F14			&Hff8d
CONST C_SYS_F15			&Hff8e
CONST C_SYS_F16			&Hff8f
CONST C_SYS_UP			&Hff90
CONST C_SYS_DOWN		&Hff91
CONST C_SYS_RIGHT		&Hff92
CONST C_SYS_LEFT		&Hff93
CONST C_SYS_HOME		&Hff94
CONST C_SYS_END			&Hff95
CONST C_SYS_PREVIOUS		&Hff96
CONST C_SYS_NEXT		&Hff97
CONST C_SYS_INSERT		&Hff98
CONST C_SYS_CLEAR		&Hff99	rem Not used in Geos.
CONST C_SYS_DELETE		&Hff9a
CONST C_SYS_PRINT_SCREEN	&Hff9b
CONST C_SYS_HELP		&Hff9d	rem Not used in Geos.
CONST C_SYS_BREAK		&Hff9e
CONST C_SYS_CAPS_LOCK		&Hffe8
CONST C_SYS_NUM_LOCK		&Hffe9
CONST C_SYS_SCROLL_LOCK		&Hffea
CONST C_SYS_LEFT_ALT		&Hffe0
CONST C_SYS_RIGHT_ALT		&Hffe1
CONST C_SYS_LEFT_CTRL		&Hffe2
CONST C_SYS_RIGHT_CTRL		&Hffe3
CONST C_SYS_LEFT_SHIFT		&Hffe4
CONST C_SYS_RIGHT_SHIFT		&Hffe5


CONST KEY_BS 		&Hff08
CONST KEY_DEL 		&Hff9a
CONST KEY_ENTER 	&Hff0d
CONST KEY_KP_RETURN 	&Hffff
CONST KEY_HOME		&Hff94
CONST KEY_TAB		&Hff09
CONST KEY_END		&Hff93
CONST KEY_ESC		&Hff1b
CONST KEY_UP_ARROW	&Hff90
CONST KEY_LEFT_ARROW	&Hff93
CONST KEY_RIGHT_ARROW	&Hff92
CONST KEY_DOWN_ARROW	&Hff91

REM date formats
CONST DTF_LONG				0
CONST DTF_LONG_CONDENSED		1
CONST DTF_LONG_NO_WEEKDAY		2
CONST DTF_LONG_NO_WEEKDAY_CONDENSED	3
CONST DTF_SHORT				4
CONST DTF_ZERO_PADDED_SHORT		5
CONST DTF_MD_LONG			6
CONST DTF_MD_LONG_NO_WEEKDAY		7
CONST DTF_MD_SHORT			8
CONST DTF_MY_LONG			9
CONST DTF_MY_SHORT			10
CONST DTF_YEAR				11
CONST DTF_MONTH				12
CONST DTF_DAY				13
CONST DTF_WEEKDAY			14
REM time formats
CONST DTF_HMS				15
CONST DTF_HM				16
CONST DTF_H				17
CONST DTF_MS				18
CONST DTF_HMS_24HOUR			19
CONST DTF_HM_24HOUR			20

REM pi
CONST PI 3.14159265359

REM Format() constants
CONST FFAF_SCIENTIFIC		&H100
CONST FFAF_PERCENT		&H80
CONST FFAF_USE_COMMAS		&H40
CONST FFAF_NO_TRAIL_ZEROS	&H20
CONST FFAF_NO_LEAD_ZERO		&H10

REM dim system as module
REM system = SystemModule()

 REM end of stdinc.bh

DisableEvents()
Dim form1 as form
form1 = MakeComponent("form","app")
CompInit form1
proto="form1"
top=91
left=96
tile=1
tileSpacing=5
caption="T-Calc"
End CompInit
Dim a_group as group
a_group = MakeComponent("group",form1)
CompInit a_group
proto="a_group"
caption=""
look=2
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
tileSpacing=5
visible=1
End CompInit
Dim start_label as label
start_label = MakeComponent("label",a_group)
CompInit start_label
proto="stop_label"
caption="??:??:??"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
start_label.name="start_label"
Dim stop_label as label
stop_label = MakeComponent("label",a_group)
CompInit stop_label
proto="stop_label"
caption="??:??:??"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
stop_label.name="stop_label"
a_group.name="a_group"
Dim b_group as group
b_group = MakeComponent("group",form1)
CompInit b_group
proto="b_group"
caption=""
look=2
tile=1
tileLayout=1
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
Dim start_button as button
start_button = MakeComponent("button",b_group)
CompInit start_button
proto="start_button"
caption="Start"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
start_button.name="start_button"
Dim stop_button as button
stop_button = MakeComponent("button",b_group)
CompInit stop_button
proto="stop_button"
caption="Stop"
sizeHControl=3
sizeVControl=3
enabled=0
visible=1
End CompInit
stop_button.name="stop_button"
b_group.name="b_group"
Dim diff_label as label
diff_label = MakeComponent("label",form1)
CompInit diff_label
proto="diff_label"
caption="Online: 00:00 min"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
diff_label.name="diff_label"
Dim t_label as label
t_label = MakeComponent("label",form1)
CompInit t_label
proto="t_label"
caption="Zeittakt: 0 s"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
t_label.name="t_label"
Dim geb_label as label
geb_label = MakeComponent("label",form1)
CompInit geb_label
proto="geb_label"
caption="akt. Gebhr: 0.00 DM"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
geb_label.name="geb_label"
Dim rest_label as label
rest_label = MakeComponent("label",form1)
CompInit rest_label
proto="rest_label"
caption="Rest: 0 s"
sizeHControl=3
sizeVControl=3
visible=1
End CompInit
rest_label.name="rest_label"
form1.width=147
form1.height=137
form1.name="form1"
Dim timedate1 as timedate
timedate1 = MakeComponent("timedate","app")
CompInit timedate1
proto="timedate1"
End CompInit
timedate1.name="timedate1"
Dim takt_timer as timer
takt_timer = MakeComponent("timer","app")
CompInit takt_timer
proto="takt_timer"
End CompInit
takt_timer.name="takt_timer"
Dim rest_timer as timer
rest_timer = MakeComponent("timer","app")
CompInit rest_timer
proto="rest_timer"
End CompInit
rest_timer.name="rest_timer"
EnableEvents()
duplo_start()
end sub

sub duplo_start()
REM place initialization code here

' Gebuehrenerfassung d.h.
' Tarif: Telekom, City, Stand: 03/98

dim starttime as long
dim stoptime as long
dim aktZeit as struct TimeOfDay
dim aktDatum as struct Date

dim seconds as integer

dim gebuehr as float
gebuehr = 0.12

dim rest as integer
rest = 0

end sub

sub module_goTo(context as string)

end sub

function module_getContext()

module_getContext = ""

end function

sub module_show()
REM code for making this module appear
form1.visible=1

end sub

sub module_hide()
REM code for making this module disappear
form1.visible=0

end sub

sub module_exit()

end sub

sub start_button_pressed(self as button)

start_button.enabled = 0	' Startbutton deaktivieren
stop_button.enabled = 1		' Stopbutton aktivieren

aktZeit  = timedate1.GetTime()		' akt. Zeit auslesen und anzeigen
start_label.caption = timedate1.FormatTime(aktZeit, 15)

starttime = timedate1.systemClock	' SystemClock auslesen und
										' Startzeit setzen

' Beschriftung der Stopzeit und Onlinezeit zuruecksetzen

stop_label.caption = "??:??:??"
diff_label.caption = "Online: 00:00 min"

' Taktzeit bestimmen und ausgeben, Takt-Intervall setzen und
' Takttimer starten, Gebuehr einblenden

t_label.caption = "Zeittakt: "+str(TaktCalc())+" s"
takt_timer.interval = 60 * TaktCalc()
takt_timer.enabled = 1
geb_label.caption = "akt. Gebhr: "+str(gebuehr)+" DM"

' Timer fuer Restzeit aktivieren und Restzeit setzen

rest_timer.enabled = 1
rest = TaktCalc() - 1

end sub

sub stop_button_pressed(self as button)

' Restzeit-Timer stoppen, Startbutton aktivieren,
' Stopbutton deaktivieren, Takt-Timer stoppen und
' Gebuehr auf 0.12 zuruecksetzen

rest_timer.enabled   = 0
start_button.enabled = 1
stop_button.enabled  = 0
takt_timer.enabled   = 0
gebuehr = 0.12

' akt. Zeit auslesen und aud Stoplabel ausgeben

aktZeit  = timedate1.GetTime()
stop_label.caption = timedate1.FormatTime(aktZeit, 15)

end sub

function TaktCalc() as integer

' Routine zur Ermittlung des aktuellen Taktes fuer
' Bereich T-elekom City

aktDatum = timedate1.GetDate()

if timedate1.GetDayOfWeek(aktDatum.year, aktDatum.month, aktDatum.day) = 0 or timedate1.GetDayOfWeek(aktDatum.year, aktDatum.month, aktDatum.day) = 6 or FeiertagCalc() = 1
' Sonntag und Samstag (gilt auch fuer Feiertage)

form1.caption = "T-C: We/Ft"

	if aktZeit.hour > 0 or aktZeit.hour = 0
		if aktZeit.hour < 5
			TaktCalc = 240
		end if
	end if

	if aktZeit.hour > 5 or aktZeit.hour = 5
		if aktZeit.hour < 21
			TaktCalc = 150
		end if
	end if

	if aktZeit.hour > 21 or aktZeit.hour = 21
		if aktZeit.hour < 24
			TaktCalc = 90
		end if
	end if

else
' Montag - Freitag

form1.caption = "T-C: Wt"

	if aktZeit.hour > 0 or aktZeit.hour = 0
		if aktZeit.hour < 5
			TaktCalc = 240
		end if
	end if

	if aktZeit.hour > 5 or aktZeit.hour = 5
		if aktZeit.hour < 9
			TaktCalc = 150
		end if
	end if

	if aktZeit.hour > 9 or aktZeit.hour = 9
		if aktZeit.hour < 18
			TaktCalc = 90
		end if
	end if

	if aktZeit.hour > 18 or aktZeit.hour = 18
		if aktZeit.hour < 21
			TaktCalc = 150
		end if
	end if

	if aktZeit.hour > 21 or aktZeit.hour = 21
		if aktZeit.hour < 24
			TaktCalc = 240
		end if
	end if

end if

end function

sub takt_timer_ring(self as timer)

' Gebuehr um eine Einheit erhoehen, akt. Gebuehr ausgeben,
' Restzeit neu setzen

gebuehr = gebuehr + 0.12
geb_label.caption = "akt. Gebhr: "+str(gebuehr)+" DM"
rest = TaktCalc() - 1

end sub

sub rest_timer_ring(self as timer)

' Restzeit ausgeben und um eins verringern

rest_label.caption = "Rest: "+str(rest)+" s"
rest = rest - 1

' aktuallisieren der Onlinezeit im Sekundentakt

OnlineZeit()

end sub

sub OnlineZeit()

' wird im Sekundentakt erneuert, da rest_timer.interval auf
' einer Sekunde steht

' auslesen der SystemClock

stoptime = timedate1.systemClock

' definieren der Variablen zu Berechnung

dim difftime as long
dim diffmin as integer
dim diffsec as integer

' Berechnung der Gesamtonlinezeit und Ausgabe

difftime = stoptime - starttime
diffsec = difftime/1000

if diffsec > 60
	diffmin = diffsec/60
	diffsec = diffsec - int(diffmin)*60 
end if

diff_label.caption = "Online: "+CorrectString(str(diffmin))+":"+CorrectString(str(diffsec))+" min"

end sub

function CorrectString(stelle as string) as string

' Korrektur der Zeitanzeige: "3" -> "03"

if Len(stelle) = 1
	CorrectString = "0"+stelle
else
	CorrectString = stelle
end if

end function

function FeiertagCalc() as integer

' 0 = kein Feiertag
' 1 = Feiertag

dim ost as integer ' OsterSonnTag
dim osm as integer ' OsterSonntagMonat
dim omt as integer ' OsterMonTag
dim omm as integer ' OsterMontagMonat
dim pst as integer ' PfingstSonnTag
dim psm as integer ' PfingstSonntagMonat
dim pmt as integer ' PfingstMonTag
dim pmm as integer ' PfingstMontagMonat
dim cht as integer ' ChristiHimmelfahrtTag
dim chm as integer ' ChristiHimmelfahtstagMonat
dim kft as integer ' Karfreitag
dim kfm as integer

' Ostersonntag (nach Carl Friedrich Gauss 1777-1855)

dim a as integer
dim b as integer
dim c as integer
dim d as integer
dim e as integer
dim j as integer

j = aktDatum.year
a = j mod 19
b = j mod 4
c = j mod 7
d = (19*a+24) mod 30
e = (2*b+4*c+6*d+5) mod 7
ost = 22+d+e
osm = 3

if ost > 31
	ost = d+e-9
	osm = 4
end if

if ost = 26 and osm = 4
	ost = 19
end if

if ost=25 and osm=4 and d=28 and e=6 and a=10
	ost = 18
end if

if ost = aktDatum.day and osm = aktDatum.month
	FeiertagCalc = 1
end if

' Ostermontag - omt, omm

omt = ost + 1
omm = osm

if omt > timedate1.GetDaysInMonth(aktDatum.year, osm)
	omm = osm+1
	omt = omt - timedate1.GetDaysInMonth(aktDatum.year, osm)
end if

if omt = aktDatum.day and omm = aktDatum.month
	FeiertagCalc = 1
end if

' Pfingsten

dim pfingsten as integer
pfingsten = ost + 49
pfingsten = pfingsten - timedate1.GetDaysInMonth(aktDatum.year, osm)

if pfingsten < timedate1.GetDaysInMonth(aktDatum.year, osm+1) or pfingsten = timedate1.GetDaysInMonth(aktDatum.year, osm+1)
	pst = pfingsten
	psm = osm+1
else
	pfingsten = pfingsten - timedate1.GetDaysInMonth(aktDatum.year, osm+1)
	pst = pfingsten
	psm = osm+2
end if

if pst = aktDatum.day and psm = aktDatum.month
	FeiertagCalc = 1
end if

' Pfingstmontag - pmt, pmm

pmt = pst + 1
pmm = psm

if pmt > timedate1.GetDaysInMonth(aktDatum.year, psm)
	pmm = psm+1
	pmt = pmt - timedate1.GetDaysInMonth(aktDatum.year, psm)
end if

if pmt = aktDatum.day and pmm = aktDatum.month
	FeiertagCalc = 1
end if

' Christi Himmelfahrt

dim himmel as integer
himmel = ost + 39
himmel = himmel - timedate1.GetDaysInMonth(aktDatum.year, osm)

if himmel < timedate1.GetDaysInMonth(aktDatum.year, osm+1) or himmel = timedate1.GetDaysInMonth(aktDatum.year, osm+1)
	cht = himmel
	chm = osm+1
else
	himmel = himmel - timedate1.GetDaysInMonth(aktDatum.year, osm+1)
	cht = himmel
	chm = osm+2
end if

if cht = aktDatum.day and chm = aktDatum.month
	FeiertagCalc = 1
end if

' Karfreitag - Ostersonntag - 2 Tage - kft, kfm

kft = ost - 2
kfm = osm

if kft < 1
	kfm = kfm-1
	kft = timedate1.GetDaysInMonth(aktDatum.year, kfm)+kft
end if

if kft = aktDatum.day and kfm = aktDatum.month
	FeiertagCalc = 1
end if

' Neujahr
if aktDatum.day = 1 and aktDatum.month = 1
	FeiertagCalc = 1
end if

'Maifeiertag
if aktDatum.day = 1 and aktDatum.month = 5
	FeiertagCalc = 1
end if

' Einheitstag
if aktDatum.day = 3 and aktDatum.month = 10
	FeiertagCalc = 1
end if

end function

